#!/usr/bin/ruby
# encoding: utf-8

require 'gtk2'
require 'vte'
require "rexml/document"
require 'retrieveDriveDetails'
require 'screenStartCheck' 
require 'screenSelectInitial'

require 'optparse'

@simulate = Array.new
@deco = true
opts = OptionParser.new 
opts.on('-s', '--simulate', :REQUIRED ) { |i| i.split(",").each { |j| @simulate.push(j) } }
opts.on('--no-deco') { @deco = false } 
opts.parse!

## define the order of pages to follow

def page_order(last_page, radio, start_radio, skipstart)
	return 1 if last_page == 0
	if last_page == 1 && radio[0].active?
		return 2
	end
	if last_page == 1 && radio[1].active?
		return 3
	end
	if last_page == 1 && radio[2].active?
		return 4
	end
	if last_page == 1 && radio[3].active? && (check_network == false || @simulate.include?("nonet"))
		return 5
	elsif last_page == 1 && radio[3].active? && check_network == true
		return 14
	end
	if last_page == 1 && radio[4].active?
		return 6
	end
	if last_page == 1 && radio[5].active?
		return 7
	end
	return 8 if last_page == 3
	return 9 if last_page == 8
	return 10 if last_page == 9
	return 11 if last_page == 10
	return 12 if last_page == 4
	return 13 if last_page == 12
	if last_page == 5 && @wlan_interface.nil? # WLAN settings
		return 15
	elsif last_page == 5
		return 14
	end
	return 15 if last_page == 14
	return 16 if last_page == 15
	return 17 if last_page == 16
	return 18 if last_page == 17
	return 19 if last_page == 6
	return 20 if last_page == 19
	return 21 if last_page == 20
	return 22 if last_page == 7
	return 23 if last_page == 22
	return 24 if last_page == 23
	if last_page == 2 && start_radio[0].active?
		return 25
	elsif last_page == 2 && start_radio[1].active?
		return 31
	elsif last_page == 2 && start_radio[2].active?
		return 32
	end
	return 26 if last_page == 25
	if last_page == 26 && ( @bad_drives.size > 0 || @simulate.include?("smartfail"))
		return 27
	elsif last_page == 26
		return 30
	end
	return 27 if last_page == 26
	return 28 if last_page == 27
	return 29 if last_page == 28
	return 26 if last_page == 31
	if last_page == 32 && @simulate.include?("ms-sys-success")
		return 33
	elsif last_page == 32
		return 34
	end
	return 1 if skipstart == true
	return 0
end


window = Gtk::Window.new
window.border_width = 10
window.window_position = Gtk::Window::POS_CENTER_ALWAYS

if @deco == false
	window.deletable = false
	window.decorated = false
	window.allow_grow = false
	window.allow_shrink = false
end
window.title = "Virenscan"
window.signal_connect('delete_event') { false }
window.signal_connect('destroy') { Gtk.main_quit }

screens = Array.new
prog_path = Array.new

# Container for buttons
buttonbox = Gtk::HBox.new
back_button = Gtk::Button.new("Zurück")
forw_button = Gtk::Button.new("Weiter")
buttonbox.pack_start_defaults back_button
buttonbox.pack_start_defaults forw_button

# container for warnings upon start
screens[0], showstart, skipstart 	= get_start_screen(forw_button, @simulate)
screens[1], radio_buttons 		= getChooserScreen(forw_button, @simulate)
screens[2], radio_failure		= getFailureScreen(forw_button, @simulate)
screens[3], photorec_combo, photorec_reread = get_photorec_screen(forw_button, @simulate)
screens[4], chntpw_combo  		= getChntpwScreen(forw_button, @simulate)
screens[5], wlan_combo, wlan_key, skip_wlan = get_virus_screen(forw_button, @simulate)
screens[6], clean_combo   		= getCleanScreen(forw_button, @simulate)
screens[7], rest_source, rest_src_reread = getRestoreScreen(forw_button, @simulate)
screens[8], photorec_ftypes, m_ftypes   = get_photorec_types_screen(forw_button, @simulate)
screens[9], photorec_tgt_combo, photorec_tgt_reread = get_photorec_target_screen(forw_button, @simulate)
screens[10], photorec_vte, photorec_prog = get_photorec_prog_screen(forw_button, @simulate)
screens[11] 				= get_photorec_finish_screen(forw_button, @simulate)
screens[12], user_combo   		= getChntpwUserScreen(forw_button, @simulate)
screens[13]               		= get_chntpw_finish_screen(forw_button, @simulate)
screens[14], upd_vte, upd_progbar      	= get_virus_sig_screen(forw_button, @simulate)
screens[15], scan_vte, scan_progbar     = get_virus_scan_screen(forw_button, @simulate)
screens[16]               		= get_virus_results_screen(forw_button, @simulate)
screens[17], repair_vte   		= get_virus_repair_screen(forw_button, @simulate)
screens[18]               		= get_virus_finish_screen(forw_button, @simulate)
screens[19], drive_box    		= get_clean_screen(forw_button, @simulate)
screens[20], clean_panel 		= get_clean_progress_screen(forw_button, @simulate)
screens[21]               		= get_clean_finish_screen(forw_button, @simulate)
screens[22], rest_targets, rest_tgt_reread = get_restore_target_screen(forw_button, @simulate)
screens[23], restore_vte, rest_tgt_prog = get_restore_progress_screen(forw_button, @simulate)
screens[24]              	 	= get_restore_finish_screen(forw_button, @simulate)
screens[25], smart_panel		= get_smart_overview_screen(forw_button, @simulate)
screens[26], smart_vte, smart_pgbar    	= get_smart_progress_screen(forw_button, @simulate)
screens[27], smart_combo  		= get_smart_fail_screen(forw_button, @simulate)
screens[28], clone_vte			= get_smart_clone_screen(forw_button, @simulate)
screens[29]				= get_smart_finish_screen(forw_button, @simulate)
screens[30]				= get_smart_ok_screen(forw_button, @simulate)
screens[31]				= get_ntldr_screen(forw_button, @simulate)
screens[32]				= get_noos_screen(forw_button, @simulate)
screens[33]				= get_noos_repaired_screen(forw_button, @simulate)
screens[34]				= get_noos_failure_screen(forw_button, @simulate)

clone_source_drives = Array.new
clone_target_drives = Array.new
clone_source_metas = Hash.new
clone_target_metas = Hash.new
clean_checkboxes = Hash.new
clean_pgbars = Hash.new
clean_vtes = Hash.new
chntpw_parts = Array.new 
nt_users = Array.new
photorec_drives = Array.new
photorec_targets = Array.new
@bad_drives = Hash.new
@wlan_interface = nil
current_drivelist = nil

fixed = Gtk::Fixed.new
screens.each { |s| fixed.put(s, 20, 20) }
fixed.put(buttonbox, 340, 430)

window.set_size_request(640, 480)
window.border_width = 0
window.add(fixed)
window.show_all
screens.each { |s| s.hide_all }

current_page = 0
current_page = 1 if skipstart == true
screens[current_page].show_all

back_button.signal_connect("clicked") {
	puts prog_path.join(", ")
	back_to = prog_path.pop
	unless back_to.nil?
		screens.each { |s| s.hide_all }
		screens[back_to].show_all
		current_page = back_to
	end
}


forw_button.signal_connect("clicked") {
	puts prog_path.join(", ")
	moveon = false
	next_screen = page_order(current_page, radio_buttons, radio_failure, skipstart)
	if next_screen == 7
		clone_source_drives, clone_source_metas = reread_full_drives(rest_source, [])
		moveon = true
	elsif next_screen == 22 
		clone_target_drives, clone_target_metas = reread_full_drives(rest_targets, [ clone_source_drives[rest_source.active] ])
		moveon = true
	elsif next_screen == 23
		msg = ""
		puts clone_source_metas[clone_source_drives[rest_source.active]].last_partend.to_s
		puts clone_target_metas[clone_target_drives[rest_targets.active]].size.to_s
		moveon = dialog_clone_compare(window, clone_target_metas[clone_target_drives[rest_targets.active]], clone_source_metas[clone_source_drives[rest_source.active]])
		if moveon == true
			back_button.sensitive = false
			forw_button.sensitive = false
			restore_finished = false
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page)
			current_page = next_screen
			restore_vte.fork_command("dd_rescue", ["dd_rescue", clone_source_drives[rest_source.active], "/dev/null" ])
			restore_vte.signal_connect("child_exited") { 
				restore_finished = true
			}
			while restore_finished == false
				rest_tgt_prog.pulse
				while (Gtk.events_pending?)
					Gtk.main_iteration
				end
				sleep 0.1
			end
			restore_vte.set_size(80, 15)
			rest_tgt_prog.fraction = 100
			while (Gtk.events_pending?)
				Gtk.main_iteration
			end
			forw_button.sensitive = true
		end
	elsif next_screen == 19
		method = "fast"
		method = "full" if clean_combo[1].active?
		clean_checkboxes, current_drivelist = fill_clean_list(drive_box, method)
		clean_pgbars, clean_vtes = fill_clean_pgbars(clean_panel, method, current_drivelist)
		moveon = true
	elsif next_screen == 20
		method = "fast"
		method = "full" if clean_combo[1].active?
		cleancount = 0
		clean_checkboxes.each { |k,v|
			if v.active?
				puts "Clean  " + k
				cleancount += 1
			else
				puts "Ignore " + k
 			end
		}
		if cleancount < 1
			dialog_empty_clean(window)
			moveon = false
		else	
			moveon = dialog_clean_warn(window, method)
			if moveon == true
				screens.each { |s| s.hide_all }
				screens[next_screen].show_all
				prog_path.push(current_page) unless prog_path[-1] == current_page
				current_page = next_screen
				run_clean(method, clean_pgbars, clean_vtes, current_drivelist, clean_checkboxes, back_button, forw_button)
			end
		end
	elsif next_screen == 21 
		moveon = true
	elsif next_screen == 4
		current_drivelist = AllDrives.new(false, false, false)
		sysparts = find_win_sysparts(current_drivelist)
		chntpw_parts = fill_chntpw_combo(chntpw_combo, sysparts) 
		if chntpw_parts.size < 1
			forw_button.sensitive = false
		end
		moveon = true
	elsif next_screen == 12	
		puts chntpw_parts[chntpw_combo.active]
		nt_users = get_nt_users(chntpw_parts[chntpw_combo.active], current_drivelist)
		fill_ntuser_combo(user_combo, nt_users)
		moveon = true
	elsif next_screen == 13
		puts nt_users[user_combo.active][0]
		### system("bash ./run_chntpw.sh")
		run_chntpw(chntpw_parts[chntpw_combo.active], nt_users[user_combo.active], current_drivelist)
		back_button.sensitive = false
		moveon = true
	elsif next_screen == 3
		photorec_drives = fill_photorec_combo(photorec_combo, AllDrives.new(false, false, false))
		forw_button.sensitive = false if photorec_drives.size < 1 
		moveon = true
	elsif next_screen == 8
		moveon = true
	elsif next_screen == 9
		types_selected = false
		photorec_ftypes.each { |t| 
			puts t.active?.to_s
			types_selected = true if t.active? == true
		}
		if types_selected == false
			moveon = dialog_photorec_allornothing(window)
		else
			moveon = true
			current_drivelist = AllDrives.new(false, false, false)
			photorec_targets = fill_photorec_targets(photorec_tgt_combo, current_drivelist, 
				photorec_drives[photorec_combo.active], 1_000_000_000)
			
		end
		if moveon == true
			
		end
	elsif next_screen == 10
		if photorec_targets.size < 1
			dialog_photorec_notarget(window)
			moveon = false
		else
			moveon = true
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page) unless prog_path[-1] == current_page
			current_page = next_screen
			run_photorec(photorec_drives[photorec_combo.active], get_photorec_categories(photorec_ftypes, m_ftypes),
				photorec_targets[photorec_tgt_combo.active], current_drivelist, 
				photorec_vte, forw_button, photorec_prog, window)
		end
	elsif next_screen == 5
		@wlan_interface = fill_wlan_combo(wlan_combo, get_networks)
		skip_wlan.active = true if @wlan_interface.nil?
		moveon = true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		dialog_nonet(window) if @wlan_interface.nil?
		# puts prog_path.join(" - ") + " + " + current_page.to_s
	elsif next_screen == 14 # && prog_path[-1] == 5
		if skip_wlan.active? == false && check_network == false && prog_path[-1] == 5
			window_net_connect(window, wlan_combo.active_text, wlan_key.text, [ forw_button, back_button] )
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page) unless prog_path[-1] == current_page
			current_page = next_screen
			puts prog_path.join(" - ") + " + " + current_page.to_s
			run_signature_update(upd_vte, upd_progbar, [ forw_button, back_button])
		elsif skip_wlan.active? == true
			next_screen = 15
		else
			screens.each { |s| s.hide_all }
			screens[next_screen].show_all
			prog_path.push(current_page) unless prog_path[-1] == current_page
			current_page = next_screen
			puts prog_path.join(" - ") + " + " + current_page.to_s
			run_signature_update(upd_vte, upd_progbar, [ forw_button, back_button])
		end
		moveon = true
	elsif next_screen == 15
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		run_clamscan(scan_vte, scan_progbar, [ forw_button, back_button])
		moveon = true
	elsif next_screen == 25
		current_drivelist = AllDrives.new(false, false, false)
		smart_res, smart_available, smart_types, smart_bad, smart_reallocated, smart_seek = smart_short_summary(current_drivelist)
		fill_smart_info(current_drivelist, smart_res, smart_available, smart_types, smart_bad, smart_reallocated, smart_seek, smart_panel)
		moveon = true
	elsif next_screen == 26
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		@bad_drives = run_smart_check(current_drivelist, smart_pgbar, [ forw_button, back_button])
		moveon = true
	elsif next_screen == 27
		moveon = true
	else
		moveon = true
	end
	if moveon == true
		screens.each { |s| s.hide_all }
		screens[next_screen].show_all
		prog_path.push(current_page) unless prog_path[-1] == current_page
		current_page = next_screen
		puts prog_path.join(" - ") + " + " + current_page.to_s
		# prog_path.push(next_screen) unless prog_path[-1] == next_screen
	end
}

rest_src_reread.signal_connect("clicked") {
	clone_source_drives = reread_full_drives(rest_source, [])
}

rest_tgt_reread.signal_connect("clicked") {
	clone_target_drives = reread_full_drives(rest_targets, [ clone_source_drives[rest_source.active] ])
}

photorec_reread.signal_connect("clicked") {
	current_drivelist = AllDrives.new(false, false, false)
	photorec_drives = fill_photorec_combo(photorec_combo, current_drivelist)
}

photorec_tgt_reread.signal_connect("clicked") {
	current_drivelist = AllDrives.new(false, false, false)
	photorec_targets = fill_photorec_targets(photorec_tgt_combo, current_drivelist, photorec_drives[photorec_combo.active])
}

Gtk.main
